unit adxOLRunTime_IMPL;

interface

uses
  ComObj, ComServ, ActiveX, Variants, adxAddIn, adxOLRunTime_TLB, StdVcl,
  Windows, SysUtils, Classes, ImgList, Controls, Forms, Dialogs;

type
  TADX_OLRunTime = class(TadxAddin, IADX_OLRunTime)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    ImageList: TImageList;
    procedure adxCOMAddInModuleAddInInitialize(Sender: TObject);
    procedure adxCOMAddInModuleAddInFinalize(Sender: TObject);
  private
    FCommandBar: TadxOLExplorerCommandBar;
  protected
  public
    procedure DoClick(Sender: TObject);
    procedure DoChange(Sender: TObject);
  end;

implementation

{$R *.dfm}

procedure TAddInModule.adxCOMAddInModuleAddInInitialize(Sender: TObject);
var
  Control: TadxCommandBarControl;
  NestedControl: TadxCommandBarControl;
begin
  Application.Handle := GetForegroundWindow;
  // CommandBar
  FCommandBar := TadxOLExplorerCommandBar.Create(Self);
  FCommandBar.CommandBarName := 'ADX2 Command Bar (how to add controls)';
  // Button
  Control := FCommandBar.Controls.Add(adxButton, 'ADX2_RT_TAG1', 0, True);
  Control.Tag := 10;
  ImageList.GetBitmap(0, Control.AsButton.Glyph);
  Control.AsButton.Caption := 'Button 1';
  Control.AsButton.Style := adxMsoButtonIconAndCaption;
  Control.AsButton.OnClick := DoClick;
  // Edit
  Control := FCommandBar.Controls.Add(adxEdit, 'ADX2_RT_TAG2', 0, True);
  Control.Tag := 100;
  Control.AsEdit.Text := 'Text';
  Control.AsEdit.OnChange := DoChange;
  // Dropdown
  Control := FCommandBar.Controls.Add(adxDropdown, 'ADX2_RT_TAG3', 0, True);
  Control.Tag := 200;
  Control.AsDropdownList.Items.Add('Item 1');
  Control.AsDropdownList.Items.Add('Item 2');
  Control.AsDropdownList.Items.Add('Item 3');
  Control.AsDropdownList.OnChange := DoChange;
  // ComboBox
  Control := FCommandBar.Controls.Add(adxComboBox, 'ADX2_RT_TAG4', 0, True);
  Control.Tag := 300;
  Control.AsComboBox.Items.Add('Item 1');
  Control.AsComboBox.Items.Add('Item 2');
  Control.AsComboBox.Items.Add('Item 3');
  Control.AsComboBox.OnChange := DoChange;
  // Popup
  Control := FCommandBar.Controls.Add(adxPopup, 'ADX2_RT_TAG5', 0, True);
  Control.AsPopup.Caption := 'Popup';
  NestedControl := Control.AsPopup.Controls.Add(adxButton, 'ADX2_RT_TAG6', 0, True);
  with NestedControl.AsButton do begin
    Tag := 20;
    Caption := 'Button 2';
    Style := adxMsoButtonCaption;
    OnClick := DoClick;
  end;
  NestedControl := Control.AsPopup.Controls.Add(adxButton, 'ADX2_RT_TAG7', 0, True);
  with NestedControl.AsButton do begin
    Tag := 30;
    Caption := 'Button 3';
    Style := adxMsoButtonCaption;
    OnClick := DoClick;
  end;
  NestedControl := Control.AsPopup.Controls.Add(adxButton, 'ADX2_RT_TAG8', 0, True);
  with NestedControl.AsButton do begin
    Tag := 40;
    Caption := 'Button 4';
    Style := adxMsoButtonCaption;
    OnClick := DoClick;
  end;
end;

procedure TAddInModule.adxCOMAddInModuleAddInFinalize(Sender: TObject);
begin
  Application.Handle := 0;
  FreeAndNil(FCommandBar);
end;

procedure TAddInModule.DoChange(Sender: TObject);
begin
  case (Sender as TadxCommandBarControl).Tag of
    // Edit
    100: ShowMessage(TadxCommandBarControl(Sender).AsEdit.Text);
    // Dropdown
    200: ShowMessage(TadxCommandBarControl(Sender).AsDropdownList.Text);
    // ComboBox
    300: ShowMessage(TadxCommandBarControl(Sender).AsComboBox.Text);
  end;
end;

procedure TAddInModule.DoClick(Sender: TObject);
begin
  case (Sender as TadxCommandBarControl).Tag of
    10: ShowMessage(TadxCommandBarControl(Sender).Caption);
    20: ShowMessage(TadxCommandBarControl(Sender).Caption);
    30: ShowMessage(TadxCommandBarControl(Sender).Caption);
    40: ShowMessage(TadxCommandBarControl(Sender).Caption);
  end;
end;

initialization
  TadxFactory.Create(ComServer, TADX_OLRunTime, CLASS_ADX_OLRunTime, TAddInModule);

end.
